#!/usr/bin/env node

const tjent = require('../index')

const help = 'tjent \n' +
        '\n' +
        'usage: tjent [PATH]' +
        '\n' +
        '\n' +
        'positionial arguments: \n' +
        '\n' +
        'PATH\tThe path of the module to generate code for' +
        '\n'

const processCommandLine = (argv) => {
  if (!argv) {
    argv = process.argv.slice(2)
  }

  if (argv.length === 0) {
    console.error('`PATH` required!')
    console.log(help)
    process.exit(1)
  }

  if (argv.indexOf('-h') !== -1 || argv.indexOf('--help') !== -1) {
    console.log(help)
    process.exit(0)
  } else {
    const path = argv[0]
    return {
      path
    }
  }
}

const main = (argv) => {
  const args = processCommandLine(argv)
  tjent(args).then((output) => {
    console.log(output)
    process.exit(0)
  }).catch((err) => {
    console.error(err)
    process.exit(1)
  })
}

main()
